package me.kawaiizenbo.moonlight.command;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.mojang.brigadier.CommandDispatcher;
import com.mojang.brigadier.ParseResults;
import com.mojang.brigadier.exceptions.CommandSyntaxException;
import me.kawaiizenbo.moonlight.command.commands.*;
import net.minecraft.class_2172;
import net.minecraft.class_310;
import net.minecraft.class_637;

public class CommandManager 
{
    private static class_310 mc = class_310.method_1551();
	private final CommandDispatcher<class_2172> DISPATCHER = new CommandDispatcher<>();
    private final class_2172 COMMAND_SOURCE = new ChatCommandSource(mc);
    private final List<Command> commands = new ArrayList<>();
    private final Map<Class<? extends Command>, Command> commandInstances = new HashMap<>();

    private CommandManager() {
    	add(new VClip());
        add(new Help());
        add(new Toggle());
        add(new Teleport());
        add(new Reset());
        add(new DeathPos());
        commands.sort(Comparator.comparing(Command::getName));
    }

    public static CommandManager get() {
        return new CommandManager();
    }

    public void dispatch(String message) throws CommandSyntaxException {
        dispatch(message, new ChatCommandSource(mc));
    }

    public void dispatch(String message, class_2172 source) throws CommandSyntaxException {
        ParseResults<class_2172> results = DISPATCHER.parse(message, source);
        DISPATCHER.execute(results);
    }

    public CommandDispatcher<class_2172> getDispatcher() {
        return DISPATCHER;
    }

    public class_2172 getCommandSource() {
        return COMMAND_SOURCE;
    }

    private final static class ChatCommandSource extends class_637 {
        public ChatCommandSource(class_310 client) {
            super(null, client);
        }
    }

    public void add(Command command) {
        commands.removeIf(command1 -> command1.getName().equals(command.getName()));
        commandInstances.values().removeIf(command1 -> command1.getName().equals(command.getName()));

        command.registerTo(DISPATCHER);
        commands.add(command);
        commandInstances.put(command.getClass(), command);
    }

    public int getCount() {
        return commands.size();
    }

    public List<Command> getAll() {
        return commands;
    }

    @SuppressWarnings("unchecked")
    public <T extends Command> T get(Class<T> klass) {
        return (T) commandInstances.get(klass);
    }

	public String getPrefix() {
		return ".";
	}
}
