package me.kawaiizenbo.moonlight.module.settings;

import me.kawaiizenbo.moonlight.Moonlight;
import me.kawaiizenbo.moonlight.util.MathUtils;
import net.minecraft.class_2561;
import net.minecraft.class_327;
import net.minecraft.class_332;

public class DoubleSetting extends Setting
{
    public double value;
    private double min, max;
    private int roundingPlace;

    boolean sliding = false;

    public DoubleSetting(String name, double value, double min, double max, int roundingPlace)
    {
        this.name = name;
        this.value = value;
        this.min = min;
        this.max = max;
        this.roundingPlace = roundingPlace;
    }

    @Override
    public void render(class_332 drawContext, int x, int y, int mouseX, int mouseY, class_327 textRenderer) 
    {
        super.render(drawContext, x, y, mouseX, mouseY, textRenderer);
        drawContext.method_51439(textRenderer, class_2561.method_43470(name), x+2, y+4, Moonlight.THEME.text.getRGB(), false);
        double diff = Math.min(100, Math.max(0, (mouseX - x)/1.9));

        if (sliding) 
        {
			if (diff == 0) 
            {
				value = min;
			}
			else 
            {
				double newValue = MathUtils.round(((diff / 100) * (max - min) + min), roundingPlace);
				value = newValue;
			}
		}

        String valueString = ""+MathUtils.round(value, roundingPlace);
        drawContext.method_51439(textRenderer, class_2561.method_43470(valueString), (x+190)-textRenderer.method_1727(valueString), y+4, Moonlight.THEME.text.getRGB(), false);
        drawContext.method_25294(x+2, y+16, x+190, y+18, 0xFF777777);
        int scaledValue = (int)((value/max)*190);
        drawContext.method_25294(x+2, y+16, (x+2)+scaledValue, y+18, Moonlight.THEME.accent.getRGB());
        drawContext.method_25294(x+2+(scaledValue-1), y+14, x+2+(scaledValue+1), y+20, Moonlight.THEME.border.getRGB());
    }

    @Override
	public void mouseClicked(double mouseX, double mouseY, int button) 
    {
		if (hovered((int)mouseX, (int)mouseY) && button == 0) 
        {
			this.sliding = true;
		}
	}
	
	@Override
	public void mouseReleased(double mouseX, double mouseY, int button) 
    {
		sliding = false;
	}
    
}
