package me.kawaiizenbo.moonlight.module.settings;

import org.lwjgl.glfw.GLFW;

import me.kawaiizenbo.moonlight.Moonlight;
import me.kawaiizenbo.moonlight.util.KeycodeUtils;
import net.minecraft.class_2561;
import net.minecraft.class_327;
import net.minecraft.class_332;

public class KeycodeSetting extends Setting 
{
    public int value;
    private boolean isWaiting = false;

    public KeycodeSetting(String name, int value)
    {
        this.name = name;
        this.value = value;
    }

    @Override
	public void mouseClicked(double mouseX, double mouseY, int button) 
    {
        if (isWaiting)
        {
            isWaiting = false;
            return;
        }
		if (hovered((int)mouseX, (int)mouseY) && button == 0) 
        {
			isWaiting = true;
		}
	}

    @Override
    public void render(class_332 drawContext, int x, int y, int mouseX, int mouseY, class_327 textRenderer) 
    {
        super.render(drawContext, x, y, mouseX, mouseY, textRenderer);
        drawContext.method_51439(textRenderer, class_2561.method_43470(name), x+2, y+8, Moonlight.THEME.text.getRGB(), false);
        if (isWaiting)
        {
            String waiting = "Press any key.";
            int twwidth = textRenderer.method_1727(waiting);
            drawContext.method_51433(textRenderer, waiting, x+190-twwidth, y+8, Moonlight.THEME.text.getRGB(), false);
        }
        else 
        {
            String key = KeycodeUtils.keyTable[value];
            if (value == GLFW.GLFW_KEY_UNKNOWN) key = "";
            int twidth = textRenderer.method_1727(key);
            drawContext.method_51433(textRenderer, key, x+190-twidth, y+8, Moonlight.THEME.text.getRGB(), false);
        }
    }

    @Override
    public void keyPressed(int keyCode, int scanCode, int modifiers)
    {
        if (isWaiting)
        {
            if (keyCode == 256)
            {
                // escape was pressed, exit safely
                isWaiting = false;
                return;
            }
            value = keyCode;
            isWaiting = false;
        }
    }
}
