package me.kawaiizenbo.moonlight.ui.clickgui;

import java.util.ArrayList;
import java.util.Map;

import me.kawaiizenbo.moonlight.Moonlight;
import me.kawaiizenbo.moonlight.module.Category;
import me.kawaiizenbo.moonlight.theme.Theme;
import me.kawaiizenbo.moonlight.util.MathUtils;
import net.minecraft.class_2561;
import net.minecraft.class_332;
import net.minecraft.class_437;

public class ClickGUIScreen extends class_437
{
    public static ClickGUIScreen INSTANCE = new ClickGUIScreen();
    public ArrayList<CategoryPane> categoryPanes;
	
	@SuppressWarnings("unchecked")
	public ClickGUIScreen() 
	{
		super(class_2561.method_43470("ClickGUI"));
		categoryPanes = new ArrayList<CategoryPane>();
		Map<String, Object> panePos = ((Map<String, Object>)Moonlight.CONFIG.config.get("panes"));
		for (Category category : Category.values())
		{ 
			if(category.name == "Special") continue;
			int xOffset = MathUtils.d2iSafe(((Map<String, Object>)panePos.get(category.name)).get("x"));
			int yOffset = MathUtils.d2iSafe(((Map<String, Object>)panePos.get(category.name)).get("y"));
			boolean collapsed = (boolean)((Map<String, Object>)panePos.get(category.name)).get("collapsed");
			categoryPanes.add(new CategoryPane(category, xOffset, yOffset, collapsed));
		}
	}

	@Override
	public void method_25394(class_332 drawContext, int mouseX, int mouseY, float delta) 
	{
		this.method_25420(drawContext, mouseX, mouseY, delta);
		drawContext.method_25294(field_22789-80, field_22790-16, field_22789, field_22790, Moonlight.THEME.border.getRGB());
		drawContext.method_25294(field_22789-78, field_22790-14, field_22789-2, field_22790-2, (mouseX > field_22789-80 && mouseY > field_22790-16) ? Moonlight.THEME.hover.getRGB() : Moonlight.THEME.background.getRGB());
		drawContext.method_51433(field_22793, "Change Theme", field_22789-75, field_22790-12, Moonlight.THEME.text.getRGB(), false);
		for (CategoryPane category : categoryPanes)
		{
			category.render(drawContext, mouseX, mouseY, delta, field_22793);
		}
	}

	@Override
	public boolean method_25402(double mouseX, double mouseY, int button) 
	{
		for (CategoryPane category : categoryPanes)
		{
			category.mouseClicked((int) mouseX, (int) mouseY, button);
		}
		if (mouseX > field_22789-80 && mouseY > field_22790-16)
		{
			if (Moonlight.THEME_IDX >= Theme.THEME_LIST.length-1) Moonlight.THEME_IDX = 0;
			else Moonlight.THEME_IDX++;
			Moonlight.THEME = Theme.THEME_LIST[Moonlight.THEME_IDX];
		}
		return super.method_25402(mouseX, mouseY, button);
	}

	@Override
	public boolean method_25406(double mouseX, double mouseY, int button) 
	{
		for (CategoryPane category : categoryPanes)
		{
			category.mouseReleased((int) mouseX, (int) mouseY, button);
		}
		return super.method_25406(mouseX, mouseY, button);
	}
	
	@Override
	public boolean method_25421() 
	{
		return false;
	}
}
