package me.kawaiizenbo.moonlight.ui.clickgui;

import me.kawaiizenbo.moonlight.Moonlight;
import me.kawaiizenbo.moonlight.module.Module;
import me.kawaiizenbo.moonlight.module.settings.Setting;
import me.kawaiizenbo.moonlight.ui.SetScreenButton;
import me.kawaiizenbo.moonlight.ui.hud.editor.HUDEditorScreen;
import me.kawaiizenbo.moonlight.util.ColorUtils;
import net.minecraft.class_2561;
import net.minecraft.class_332;
import net.minecraft.class_437;

public class SettingsScreen extends class_437 
{
    private Module module;
    private SetScreenButton backButton;
    private SetScreenButton editButton;

    boolean dragging = false;
    int startX, startY, x = (ClickGUIScreen.INSTANCE.field_22789/2)-112, y = (ClickGUIScreen.INSTANCE.field_22790/2)-96, windowWidth = 224, windowHeight = 192;

    public SettingsScreen(Module module) 
    {
        super(class_2561.method_43470("Settings"));
        backButton = new SetScreenButton(ColorUtils.underline + "< Back", x+4, y+4, ClickGUIScreen.INSTANCE);
        editButton = new SetScreenButton(ColorUtils.underline + "Edit", x+windowWidth-22, y+4, HUDEditorScreen.INSTANCE);
        this.module = module;
    }

    @Override
	public void method_25394(class_332 drawContext, int mouseX, int mouseY, float delta) 
	{
        this.method_25420(drawContext, mouseX, mouseY, delta);

        // move window if dragging
        if (dragging)
        {
            x = mouseX - startX;
            y = mouseY - startY;
        }
        drawContext.method_25294(x, y, x+windowWidth, y+windowHeight, Moonlight.THEME.themedWindowBorders ? Moonlight.THEME.border.getRGB() : module.category.color);
        drawContext.method_25294(x+2, y+2, x+windowWidth-2, y+windowHeight-2, Moonlight.THEME.background.getRGB());
        drawContext.method_25294(x, y, x+windowWidth, y+16, Moonlight.THEME.themedWindowBorders ? Moonlight.THEME.border.getRGB() : module.category.color);
        //drawContext.fill(x+2, y+2, x+(windowWidth-2), y+14, Moonlight.THEME.background.getRGB());
        drawContext.method_51433(field_22793, module.name, x+((windowWidth/2)-(field_22793.method_1727(module.name)/2)), y+4, Moonlight.THEME.headerText.getRGB(), false);
        drawContext.method_51433(field_22793, module.description, x+8, y+24, Moonlight.THEME.text.getRGB(), false);
        backButton.render(drawContext, field_22793, mouseX, mouseY, x+4, y+4);
        if (module.showEditButton) editButton.render(drawContext, field_22793, mouseX, mouseY, x+windowWidth-22, y+4);
		int yOffset = y+40;
		for (Setting setting : module.settings)
		{
			setting.render(drawContext, x+16, yOffset, mouseX, mouseY, field_22793);
			yOffset += 25;
		}
	}

    public boolean barHovered(int mouseX, int mouseY) 
    {
		return mouseX >= x && mouseX <= x + field_22789 && mouseY >= y && mouseY <= y + 16;
	}
    
    @Override
    public boolean method_25421() 
    {
        return false;
    }

    @Override
    public boolean method_25402(double mouseX, double mouseY, int button)
    {
        if (barHovered((int)mouseX, (int)mouseY))
        {
            startX = (int)mouseX-x;
            startY = (int)mouseY-y;
            dragging = true;
        }
        backButton.mouseClicked((int)mouseX, (int)mouseY);
        editButton.mouseClicked((int)mouseX, (int)mouseY);
        for (Setting setting : module.settings)
        {
            setting.mouseClicked(mouseX, mouseY, button);
        }
        return super.method_25402(mouseX, mouseY, button);
    }

    @Override
    public boolean method_25406(double mouseX, double mouseY, int button)
    {
        dragging = false;
        for (Setting setting : module.settings)
        {
            setting.mouseReleased(mouseX, mouseY, button);
        }
        return super.method_25406(mouseX, mouseY, button);
    }

    @Override
    public boolean method_25404(int keyCode, int scanCode, int modifiers)
    {
        for (Setting setting : module.settings)
        {
            setting.keyPressed(keyCode, scanCode, modifiers);
        }
        return super.method_25404(keyCode, scanCode, modifiers);
    }
}
